/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * ================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://forceten.tidalwave.it
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: EmblemIconProviderDecorator.java,v c9bf78d7704e 2010/02/14 03:07:46 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.geocoding.node.impl;

import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import java.awt.Image;
import org.openide.util.Lookup;
import it.tidalwave.swing.IconResizer;  
import it.tidalwave.util.IconProvider;
import it.tidalwave.util.IconProvider.Type;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.netbeans.util.DeferredIconProvider;
import it.tidalwave.geo.geocoding.GeoCoderEntity;
import static it.tidalwave.geo.geocoding.GeoCoderEntity.EmblemFactory.EmblemFactory;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: EmblemIconProviderDecorator.java,v c9bf78d7704e 2010/02/14 03:07:46 fabrizio $
 *
 **********************************************************************************************************************/
public class EmblemIconProviderDecorator extends DeferredIconProvider
  {
    @Nonnull
    private final Lookup lookup;

    public EmblemIconProviderDecorator (final @Nonnull IconProvider iconProviderDelegate,
                                        final @Nonnull Lookup lookup)
      {
        super(iconProviderDelegate);
        this.lookup = lookup;
      }

    @Override
    protected Image createIcon (final @Nonnull Type type, final @Nonnegative int size)
      throws NotFoundException
      {
        final GeoCoderEntity geoCoderEntity = NotFoundException.throwWhenNull(lookup.lookup(GeoCoderEntity.class), "");
        return IconResizer.scaledImage(geoCoderEntity.as(EmblemFactory).findEmblem(size), size);
      }
  }
